function paral_LEC(	img_colr_name,Amax,LUTfile,img_ref_name,choix_spec,...
					sig0,LEC_G1_colr_name,LEC_G1_gmap_name,...
					sig1,sig2,sig3)


choix_spec  = str2double(choix_spec);
img_colr    = double(imread(img_colr_name)); 		    % [0,255] double
img_gray    = sum(img_colr,3)/3; 						% [0,255] double

Amax        = str2double(Amax);
sig0        = str2double(sig0);
sig1        = str2double(sig1);
sig2        = str2double(sig2);
sig3        = str2double(sig3);



% Reading the DxO LUT --------------------------------- %
LUTfile_id  = fopen(LUTfile,'r');                       % Read DxO LUT
doplut      = NaN(32768,1);
for n=1:32768
    doplut(n)   = str2double(fgetl(LUTfile_id));
end
fclose(LUTfile_id);
doplut      = doplut(1:128:end)/128;                    % LUT Conversion:
LUT         = @(u)(doplut(round(u+1)));                 %      15 >> 8 bits
% Reading the DxO LUT --------------------------------- %


% For all the algorithms below
img_flp = cat(1,img_gray,img_gray(end:-1:1,:));       	% img 2x bigger
img_flp = cat(2,img_flp,img_flp(:,end:-1:1));           % img 4x bigger
img_fft = fft2(img_flp);                      			% FT{img}



% I. Simple Gaussian. --------------------------------- % -----------------

% Fourrier Gaussian Filtering %                     --- % -----------------
[H,W]   = size(img_gray);
[Gh,Gw] = meshgrid( -pi:(pi/W):+pi-(pi/W), -pi:(pi/H):+pi-(pi/H) );                     
gauss 	= exp(-(sig0^2)*(Gh.^2 + Gw.^2)/2);       		% FT{gaussian_sig}
img_flt = abs(ifft2(img_fft.*fftshift(gauss)));         % gauss. filtering
img_flt = img_flt(1:H,1:W);                             % crop >> img_filt


LEC_G1_gmap = max(LUT(img_flt)./round(img_flt),0);      % max avoids NaN
LEC_G1_gmap = max(LEC_G1_gmap.*((img_gray + .6*(img_gray-img_flt))./img_gray),0);

% LEC_G1_gray = zeros(size(img_gray)); % Pas besoin de image corr gray
% LEC_G1_gray = img_gray.*LEC_G1_gmap;

LEC_G1_colr = zeros(size(img_colr));
LEC_G1_colr(:,:,1) = max(0,min(img_colr(:,:,1).*LEC_G1_gmap));
LEC_G1_colr(:,:,2) = max(0,min(img_colr(:,:,2).*LEC_G1_gmap));
LEC_G1_colr(:,:,3) = max(0,min(img_colr(:,:,3).*LEC_G1_gmap));

% Specification (channel per channel)
REF = double(imread(img_ref_name));
if choix_spec == 1
    
    lec_g1_spec_gray = 255*specification((img_gray.*LEC_G1_gmap)/255,sum(REF,3)/(3*255));
    lec_g1_spec_gmap = max(lec_g1_spec_gray./img_gray,0);
    lec_g1_spec_gmap(lec_g1_spec_gmap >= 50) = 0;
    
    LEC_G1_spec_colr(:,:,1) = img_colr(:,:,1).*lec_g1_spec_gmap;
    LEC_G1_spec_colr(:,:,2) = img_colr(:,:,2).*lec_g1_spec_gmap;
    LEC_G1_spec_colr(:,:,3) = img_colr(:,:,3).*lec_g1_spec_gmap;
else
    
    LEC_G1_spec_colr(:,:,1) = 255*specification(LEC_G1_colr(:,:,1)/255,REF(:,:,1)/255);
    LEC_G1_spec_colr(:,:,2) = 255*specification(LEC_G1_colr(:,:,2)/255,REF(:,:,2)/255);
    LEC_G1_spec_colr(:,:,3) = 255*specification(LEC_G1_colr(:,:,3)/255,REF(:,:,3)/255);
end

imwrite(uint8(LEC_G1_colr),LEC_G1_colr_name);
imwrite(uint8(LEC_G1_gmap*255/Amax),LEC_G1_gmap_name);
imwrite(uint8(LEC_G1_spec_colr),['spec_' LEC_G1_colr_name]);













% 
% MSR_gray    = zeros(size(img_gray));
% LEC_gmap    = zeros(size(img_gray));
% 
% sigma       = [str2double(sig1),str2double(sig2),str2double(sig3)];
% N           = length(sigma);
% [H,W]       = size(img_gray);
% [Gh,Gw]     = meshgrid( -pi:(pi/W):+pi-(pi/W), -pi:(pi/H):+pi-(pi/H) );
% 
% for n=1:N
%     % Fourrier Gaussian Filtering %                     %------------------                       
%     gauss = exp(-(sigma(n)^2)*(Gh.^2 + Gw.^2)/2);       % FT{gaussian_sig}
%     img_p = cat(1,img_gray,img_gray(end:-1:1,:));       % img 2x bigger
%     img_p = cat(2,img_p,img_p(:,end:-1:1));             % img 4x bigger
%     img_t = fftshift(fft2(img_p));                      % FT{img}
%     img_f = abs(ifft2(fftshift(img_t.*gauss)));         % gauss. filtering
%     img_f = img_f(1:H,1:W);                             % crop >> img_filt
%     
%     % Multiscale Retinex %
%     MSR_gray = MSR_gray + (log(255*img_gray+1)-log(255*img_f+1))/N;
%     
%     % Local Exposure Correction %
%     LEC_gmap = LEC_gmap + (LUT(img_f)./img_f)/N;
% end
% clear gauss img_p img_t img_f Gh Gw;
% 
% gain_max        = 255./max(img_colr,[],3);
% 
% % Multiscale Retinex %
% MSR_gray        = ipolSCB(MSR_gray,1,1,255);            % Simp.Col.Balance
% MSR_gainmap     = min(MSR_gray./img_gray,gain_max);     % To avoid col. sat
% MSR_gainmap(MSR_gainmap>L) = L;                         % Limitation at *L*
% 
% MSR_colr(:,:,1) = img_colr(:,:,1).*MSR_gainmap;
% MSR_colr(:,:,2) = img_colr(:,:,2).*MSR_gainmap;
% MSR_colr(:,:,3) = img_colr(:,:,3).*MSR_gainmap;
% 
% % Local Exposure Correction %
% LEC_gainmap     = min(LEC_gmap,gain_max);               % To avoid col. sat
% LEC_gainmap(LEC_gainmap>L) = L;                         % Limitation at *L*
% 
% LEC_colr(:,:,1) = img_colr(:,:,1).*LEC_gainmap;
% LEC_colr(:,:,2) = img_colr(:,:,2).*LEC_gainmap;
% LEC_colr(:,:,3) = img_colr(:,:,3).*LEC_gainmap;
% 
% % Saving outputs %
% imwrite(uint8(MSR_colr),'MSR_output_color.png');
% imwrite(uint8(LEC_colr),'LEC_output_color.png');
% imwrite(uint8(ipolSCB(MSR_gainmap,0,0,255)),'MSR_gainmap_min0max3.png');
% imwrite(uint8(ipolSCB(LEC_gainmap,0,0,255)),'LEC_gainmap_min0max3.png');
% 

end
