function step3_gainmaps(img_colr_name,Amax,LUTfile,img_ref_name,choix_spec,...
                        ACE_gray_name,ACE_colr_name,ACE_gmap_name,...
                        LCC_gray_name,LCC_colr_name,LCC_gmap_name,...
                        BFS_base_name,BFS_colr_name,BFS_gmap_name)

% GLOBAL %
img_colr    = double(imread(img_colr_name));
Amax        = str2double(Amax);
choix_spec  = str2double(choix_spec);
img_gray    = double(uint8(sum(img_colr,3)/3));     % With quantif:
                                                    % exactely the same
                                                    % input as in the
                                                    % enhancement algorithm
[H,W]       = size(img_gray);
MAX_gmap    = min(255./max(img_colr,[],3),Amax);    % NaNs become Amax



% % spec_input  = specification(img_gray/255,REF_gray/255)*255;
% % spec_gains  = max(spec_input./img_gray,0);          % max() avoid NaNs
% % spec_gains(spec_gains >= 50) = 0;
% % spec_input_colr = zeros(size(img_colr));


% SPECIFY the input gray levels on the reference gray level, compute the
% gains and apply it to the input color image %
REF = double(imread(img_ref_name));
if choix_spec == 1
    spec_input = 255*specification(img_gray/255,sum(REF,3)/(3*255));
    spec_gains = max(spec_input./img_gray,0);
    spec_gains(spec_gains >= 50) = 0;
    spec_input_colr(:,:,1) = img_colr(:,:,1).*spec_gains;
    spec_input_colr(:,:,2) = img_colr(:,:,2).*spec_gains;
    spec_input_colr(:,:,3) = img_colr(:,:,3).*spec_gains;
else
    spec_input_colr(:,:,1) = 255*specification(img_colr(:,:,1)/255,REF(:,:,1)/255);
    spec_input_colr(:,:,2) = 255*specification(img_colr(:,:,2)/255,REF(:,:,2)/255);
    spec_input_colr(:,:,3) = 255*specification(img_colr(:,:,3)/255,REF(:,:,3)/255);
end
imwrite(uint8(spec_input_colr),['spec_' img_colr_name]);


% ACE % =================================================================
ACE_gray    = double(imread(ACE_gray_name));
ACE_gray    = ACE_gray(:,:,1);                      % for TIF case
ACE_gmap    = min(max(ACE_gray./img_gray,0),MAX_gmap);

ACE_colr        = zeros(H,W,3);
ACE_colr(:,:,1) = img_colr(:,:,1).*ACE_gmap;
ACE_colr(:,:,2) = img_colr(:,:,2).*ACE_gmap;
ACE_colr(:,:,3) = img_colr(:,:,3).*ACE_gmap;

% (Specification) %
% spec_ACE        = specification(ACE_gray/255,REF_gray/255)*255;
% spec_ACE_gmap   = max(spec_ACE./img_gray,0);
% spec_ACE_gmap(spec_ACE_gmap >= 50) = 0;
% spec_ACE_colr   = zeros(H,W,3);
% spec_ACE_colr(:,:,1) = img_colr(:,:,1).*spec_ACE_gmap;
% spec_ACE_colr(:,:,2) = img_colr(:,:,2).*spec_ACE_gmap;
% spec_ACE_colr(:,:,3) = img_colr(:,:,3).*spec_ACE_gmap;
if choix_spec == 1

    spec_ACE = 255*specification(ACE_gray/255,sum(REF,3)/(3*255));
    spec_ACE_gmap = max(spec_ACE./img_gray,0);
    spec_ACE_gmap(spec_ACE_gmap >= 50) = 0;
    spec_ACE_colr(:,:,1) = img_colr(:,:,1).*spec_ACE_gmap;
    spec_ACE_colr(:,:,2) = img_colr(:,:,2).*spec_ACE_gmap;
    spec_ACE_colr(:,:,3) = img_colr(:,:,3).*spec_ACE_gmap;
else
    
    spec_ACE_colr(:,:,1) = 255*specification(ACE_colr(:,:,1)/255,REF(:,:,1)/255);
    spec_ACE_colr(:,:,2) = 255*specification(ACE_colr(:,:,2)/255,REF(:,:,2)/255);
    spec_ACE_colr(:,:,3) = 255*specification(ACE_colr(:,:,3)/255,REF(:,:,3)/255);
end

imwrite(uint8(ACE_colr),ACE_colr_name);
imwrite(uint8(ACE_gmap*255/Amax),ACE_gmap_name);
imwrite(uint8(spec_ACE_colr),['spec_' ACE_colr_name]);
clear ACE_colr ACE_gmap


% LCC % =================================================================
LCC_gray    = double(imread(LCC_gray_name));
LCC_gray    = LCC_gray(:,:,1);                      % for TIF case
LCC_gmap    = min(max(LCC_gray./img_gray,0),MAX_gmap);

LCC_colr        = zeros(H,W,3);
LCC_colr(:,:,1) = img_colr(:,:,1).*LCC_gmap;
LCC_colr(:,:,2) = img_colr(:,:,2).*LCC_gmap;
LCC_colr(:,:,3) = img_colr(:,:,3).*LCC_gmap;

% (Specification) %
if choix_spec == 1

    spec_LCC = 255*specification(LCC_gray/255,sum(REF,3)/(3*255));
    spec_LCC_gmap = max(spec_LCC./img_gray,0);
    spec_LCC_gmap(spec_LCC_gmap >= 50) = 0;
    spec_LCC_colr(:,:,1) = img_colr(:,:,1).*spec_LCC_gmap;
    spec_LCC_colr(:,:,2) = img_colr(:,:,2).*spec_LCC_gmap;
    spec_LCC_colr(:,:,3) = img_colr(:,:,3).*spec_LCC_gmap;
else
    
    spec_LCC_colr(:,:,1) = 255*specification(LCC_colr(:,:,1)/255,REF(:,:,1)/255);
    spec_LCC_colr(:,:,2) = 255*specification(LCC_colr(:,:,2)/255,REF(:,:,2)/255);
    spec_LCC_colr(:,:,3) = 255*specification(LCC_colr(:,:,3)/255,REF(:,:,3)/255);
end

imwrite(uint8(LCC_colr),LCC_colr_name);
imwrite(uint8(LCC_gmap*255/Amax),LCC_gmap_name);
imwrite(uint8(spec_LCC_colr),['spec_' LCC_colr_name]);
clear LCC_colr LCC_gmap


% BFS (Bilateral Filter Standard) % ======================================
% N.B.: For BFS, no gain limitation, because we're using the DxO LUT.

BFS_base 	= double(imread(BFS_base_name));
BFS_base 	= BFS_base(:,:,1);						% Just in case...

% Reading the DxO LUT -----------------------------	%
LUTfile_id  = fopen(LUTfile,'r');                   % Read DxO LUT
doplut      = NaN(32768,1);
for n=1:32768
    doplut(n)   = str2double(fgetl(LUTfile_id));
end
fclose(LUTfile_id);
doplut      = doplut(1:128:end)/128;                % LUT Conversion:
LUT         = @(u)(doplut(round(u+1)));             %      15 >> 8 bits
% Reading the DxO LUT ----------------------------- %

BFS_gmap 	= max(LUT(BFS_base)./round(BFS_base),0);% max avoids Nan
BFS_gmap 	= max(BFS_gmap.*((img_gray + .6*(img_gray-BFS_base))./img_gray),0);

BFS_colr 	= zeros(H,W,3);
BFS_colr(:,:,1) = max(0,min(255,img_colr(:,:,1).*BFS_gmap)); % Keep in [0,255]
BFS_colr(:,:,2) = max(0,min(255,img_colr(:,:,2).*BFS_gmap));
BFS_colr(:,:,3) = max(0,min(255,img_colr(:,:,3).*BFS_gmap));

% (Specification) %
if choix_spec == 1

    spec_BFS = 255*specification((img_gray.*BFS_gmap)/255,sum(REF,3)/(3*255));
    spec_BFS_gmap = max(spec_BFS./img_gray,0);
    spec_BFS_gmap(spec_BFS_gmap >= 50) = 0;
    spec_BFS_colr(:,:,1) = img_colr(:,:,1).*spec_BFS_gmap;
    spec_BFS_colr(:,:,2) = img_colr(:,:,2).*spec_BFS_gmap;
    spec_BFS_colr(:,:,3) = img_colr(:,:,3).*spec_BFS_gmap;
else
    spec_BFS_colr(:,:,1) = 255*specification(BFS_colr(:,:,1)/255,REF(:,:,1)/255);
    spec_BFS_colr(:,:,2) = 255*specification(BFS_colr(:,:,2)/255,REF(:,:,2)/255);
    spec_BFS_colr(:,:,3) = 255*specification(BFS_colr(:,:,3)/255,REF(:,:,3)/255);
end

imwrite(uint8(BFS_colr),BFS_colr_name);
imwrite(uint8(BFS_gmap*255/Amax),BFS_gmap_name);
imwrite(uint8(spec_BFS_colr),['spec_' BFS_colr_name]);

end